/* Code for comp102 lecture
 * Name:pondy
 */

import ecs100.*;
import java.awt.Color; 
import java.util.*;

/** A grove of Butterflies which fly around and land
 */
public class ButterflyGrove{
    public static final double GROUND_LEVEL = 400;  

    /** Set up the interface and draw the initial screen */
    public void setupGUI(){
        UI.addButton("Clear", this::drawGround);
        UI.addButton("One", this::oneButterfly);
        UI.addButton("Two", this::twoButterflies);
        UI.addButton("Lots", this::lots);
        UI.addButton("Stop", ()->{this.flying=false;});
        UI.addButton("Hop", this::butterfliesHop);
        UI.addButton("Quit", UI::quit);
        UI.setDivider(0);
        this.drawGround();
    }

    /** Clear the window and draw the ground */
    public void drawGround(){
        UI.clearPanes();
        UI.setColor(new Color(100,80,40));   // a dark brown
        UI.fillRect(0,GROUND_LEVEL,800,6);
        UI.setDivider(0);
    }   
    
    /** Make one butterfly then make it move and land */
    public void oneButterfly(){
        Butterfly b1 = new Butterfly(50, 200);
        b1.move(5);
        b1.move(10);
        b1.move(15);
        b1.move(10);
        b1.move(10);
        b1.move(10);
        b1.move(10);
        b1.move(10);
        b1.move(10);
        b1.move(10);
        b1.move(10);
        b1.land();
    }

    /** Make two butterflies that move and land */
    public void twoButterflies(){
        Butterfly b1 = new Butterfly(500*Math.random(), 200);
        b1.move(5);
        b1.move(10);
        b1.move(15);
        b1.land();
        Butterfly b2 = new Butterfly(100, GROUND_LEVEL*Math.random());
        b1.move(10);
        b2.move(10);
        b1.move(10);
        b2.move(10);
        b1.move(10);
        b2.move(10);
        b1.move(10);
        b1.move(10);
        b1.land();
        b2.move(20);
    }

    /** Make two butterflies and make them repeatedly do a "hop" */
    public void butterfliesHop(){
        Butterfly b1 = new Butterfly(50, 300);
        Butterfly b2 = new Butterfly(300, 300);
        this.flyAndLand(b1);
        this.flyAndLand(b2);
        this.flyAndLand(b1);
        this.flyAndLand(b2);
        this.flyAndLand(b1);
        this.flyAndLand(b2);
    } 

    /** Get a butterfly to hop by moving up three times then landing */
    public void flyAndLand(Butterfly b){
        b.move(20);
        b.move(30);
        b.move(45);
        b.land();
    }

    
    public  boolean flying = true;  

    /** Make lots of butterflies and make them all move and occasionally land */
    public void lots(){
        int count = 10;
        ArrayList<Butterfly> all = new ArrayList<Butterfly>();
        for (int i=0; i<count; i++){
            Butterfly b = new Butterfly(600*Math.random(),400*Math.random());
            all.add(b);
        }
        this.flying = true;
        while (flying){
            for (Butterfly b : all){
                b.move(10*Math.random());
                if (Math.random()<.02){ 
                    b.land();
                }
            }

        }
    }

     public static void main(String[] args){
         ButterflyGrove bg = new ButterflyGrove();
         bg.setupGUI();
        }
}
